{***************************************************************************
       NET DIR  Paradox
    BDE,   .
  :  change_NetDir(<   NET DIR( )>);
 : True -    
          False -   .
  ,  BDE     
   .    NET DIR   
    ,  BDE.
        NET DIR .
 ****************************************************************************
      .. E-mail: i7@mail.ru
                                 : http://i7.da.ru
    "How to change NET DIR programmatically so it persists"
                by Steven Randolph ("Delphi White Papers" from Delphi 5 Direct.
 ****************************************************************************}
unit netdir_ch;

interface
  uses bde,dbtables, SysUtils;
var
  hCur : hDBICur;
  Config : CFGDesc;
  ContinueIt: boolean;
//**************************************************
function change_NetDir(newNetDir: string): Boolean;
//**************************************************
implementation

function change_NetDir(newNetDir: string): Boolean;
begin
  if DbiInit(nil) = DBIERR_NONE then
  begin
    hCur := nil;
    if DbiOpenCfgInfoList(nil, dbiREADWRITE, cfgPersistent,
        '\DRIVERS\PARADOX\INIT', hCur) = DBIERR_NONE then
    begin
      if DbiSetToBegin(hCur) = DBIERR_NONE then
      begin
        ContinueIt := true;
        while ContinueIt do
        begin
          if(DbiGetNextRecord(hCur, dbiWRITELOCK, @Config, nil)
                 <> DBIERR_NONE) then
            ContinueIt := false
          else
            if StrIComp(Config.szNodeName, 'NET DIR') = 0 then
            begin
              StrCopy(Config.szValue, PChar(newNetDir));
              DbiModifyRecord(hCur, @Config, true);
              ContinueIt := false
            end;
        end;
      end;
    end;
    DbiExit();
    Result:=True;
    exit;
  end;
  Result:=False;
end;  
end.
